<?php
/**
 * Clase Base FN para BaseArArqueoDetalleProductoFN
 *
 * @package    
 * @subpackage BaseArArqueoDetalleProductoFN
 * @author     Willy
 * @version    SVN:: BaseArArqueoDetalleProductoFN.class.php,v 1.1 2020-07-06 21:36:14 william.taype Exp $
 */
class BaseArArqueoDetalleProductoFN extends ArArqueoDetalleProductoBN
{
  private static $fieldNames = array (
    'Idclase'=>'idclase', 'Idsucursal'=>'idsucursal', 'Idmercado'=>'idmercado', 'Idcolaborador'=>'idcolaborador', 'Fecha'=>'fecha', 'Idcliente'=>'idcliente', 'Idprestamo'=>'idprestamo', 'Correlativo'=>'correlativo', 'Nombrecliente'=>'nombrecliente', 'Idtipoproducto'=>'idtipoproducto', 'Descripciontipoproducto'=>'descripciontipoproducto', 'Decripcionproducto'=>'decripcionproducto', 'Cantidad'=>'cantidad', 'Preciounitario'=>'preciounitario', 'Subtotal'=>'subtotal', 'Estado'=>'estado', 'Idpagoreferencia'=>'idpagoreferencia', 'Fecharegistro'=>'fecharegistro', 'Usuarioregistro'=>'usuarioregistro'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, correlativo, nombrecliente, idtipoproducto, descripciontipoproducto, decripcionproducto, cantidad, preciounitario, subtotal, estado, idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_producto WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
       $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, correlativo, nombrecliente, idtipoproducto, descripciontipoproducto, decripcionproducto, cantidad, preciounitario, subtotal, estado, idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_producto WHERE 1 ".$where;
       $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdclase()){ $where .= " AND idclase = '".$this->getIdclase()."'"; }
      if($this->getIdsucursal()){ $where .= " AND idsucursal = '".$this->getIdsucursal()."'"; }
      if($this->getIdmercado()){ $where .= " AND idmercado = '".$this->getIdmercado()."'"; }
      if($this->getIdcolaborador()){ $where .= " AND idcolaborador = '".$this->getIdcolaborador()."'"; }
      if($this->getFecha()){ $where .= " AND fecha = '".$this->getFecha()."'"; }
      if($this->getIdcliente()){ $where .= " AND idcliente = '".$this->getIdcliente()."'"; }
      if($this->getIdprestamo()){ $where .= " AND idprestamo = '".$this->getIdprestamo()."'"; }
      if($this->getCorrelativo()){ $where .= " AND correlativo = '".$this->getCorrelativo()."'"; }
      if($this->getNombrecliente()){ $where .= " AND nombrecliente = '".$this->getNombrecliente()."'"; }
      if($this->getIdtipoproducto()){ $where .= " AND idtipoproducto = '".$this->getIdtipoproducto()."'"; }
      if($this->getDescripciontipoproducto()){ $where .= " AND descripciontipoproducto = '".$this->getDescripciontipoproducto()."'"; }
      if($this->getDecripcionproducto()){ $where .= " AND decripcionproducto = '".$this->getDecripcionproducto()."'"; }
      if($this->getCantidad()){ $where .= " AND cantidad = '".$this->getCantidad()."'"; }
      if($this->getPreciounitario()){ $where .= " AND preciounitario = '".$this->getPreciounitario()."'"; }
      if($this->getSubtotal()){ $where .= " AND subtotal = '".$this->getSubtotal()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getIdpagoreferencia()){ $where .= " AND idpagoreferencia = '".$this->getIdpagoreferencia()."'"; }
      if($this->getFecharegistro()){ $where .= " AND fecharegistro = '".$this->getFecharegistro()."'"; }
      if($this->getUsuarioregistro()){ $where .= " AND usuarioregistro = '".$this->getUsuarioregistro()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idclase, idsucursal, idmercado, idcolaborador, fecha, idcliente, idprestamo, correlativo, nombrecliente, idtipoproducto, descripciontipoproducto, decripcionproducto, cantidad, preciounitario, subtotal, estado, idpagoreferencia, fecharegistro, usuarioregistro FROM ar_arqueo_detalle_producto WHERE 1 AND idclase='".$this->getIdclase()."' AND idsucursal='".$this->getIdsucursal()."' AND idmercado='".$this->getIdmercado()."' AND idcolaborador='".$this->getIdcolaborador()."' AND fecha='".$this->getFecha()."' AND idcliente='".$this->getIdcliente()."' AND idprestamo='".$this->getIdprestamo()."' AND correlativo='".$this->getCorrelativo()."'; ";
       $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseArArqueoDetalleProductoFN = new BaseArArqueoDetalleProductoFN();
    $o_BaseArArqueoDetalleProductoFN->setIdclase($o_propel->idclase);
    $o_BaseArArqueoDetalleProductoFN->setIdsucursal($o_propel->idsucursal);
    $o_BaseArArqueoDetalleProductoFN->setIdmercado($o_propel->idmercado);
    $o_BaseArArqueoDetalleProductoFN->setIdcolaborador($o_propel->idcolaborador);
    $o_BaseArArqueoDetalleProductoFN->setFecha($o_propel->fecha);
    $o_BaseArArqueoDetalleProductoFN->setIdcliente($o_propel->idcliente);
    $o_BaseArArqueoDetalleProductoFN->setIdprestamo($o_propel->idprestamo);
    $o_BaseArArqueoDetalleProductoFN->setCorrelativo($o_propel->correlativo);
    $o_BaseArArqueoDetalleProductoFN->setNombrecliente($o_propel->nombrecliente);
    $o_BaseArArqueoDetalleProductoFN->setIdtipoproducto($o_propel->idtipoproducto);
    $o_BaseArArqueoDetalleProductoFN->setDescripciontipoproducto($o_propel->descripciontipoproducto);
    $o_BaseArArqueoDetalleProductoFN->setDecripcionproducto($o_propel->decripcionproducto);
    $o_BaseArArqueoDetalleProductoFN->setCantidad($o_propel->cantidad);
    $o_BaseArArqueoDetalleProductoFN->setPreciounitario($o_propel->preciounitario);
    $o_BaseArArqueoDetalleProductoFN->setSubtotal($o_propel->subtotal);
    $o_BaseArArqueoDetalleProductoFN->setEstado($o_propel->estado);
    $o_BaseArArqueoDetalleProductoFN->setIdpagoreferencia($o_propel->idpagoreferencia);
    $o_BaseArArqueoDetalleProductoFN->setFecharegistro($o_propel->fecharegistro);
    $o_BaseArArqueoDetalleProductoFN->setUsuarioregistro($o_propel->usuarioregistro);
    return $o_BaseArArqueoDetalleProductoFN;
  }
}